#! /usr/bin/perl -w
use strict;
use utf8;
use encoding 'utf8';

# *.fmt 作成
# 直接実行, 管理者用パスワードが必要.

# tex なら 'ptex' の行に # を付け替えること
my $tex = 'ptex';
#my $tex = 'tex';

# format を作りたいファイルのアイコンをこのウィンドウにおとす

my $docPath = shift or die "Drop me a tex file\n";

my $bin = '/usr/local/bin';
$bin = $ENV{"JTeXEditTeXBinPath"} if ($ENV{"JTeXEditTeXBinPath"});
my $kpsewhich = "$bin/kpsewhich";
die "kpsewhich not found" unless (-e $kpsewhich);
print "\nusing $kpsewhich\n";
my ($root) = $bin =~ m|^(.*)/[^/]*$|;

# search web2c in texmf-local or texmf
my $web2c = '';
{
	my $text = `$kpsewhich -show-path 'web2c files'`;
	my @list = split(/:|!/, $text);
	for (@list) {
		if (m|/texmf-local/web2c$|) {
			$web2c = $_;
			last;
		} elsif (m|^$root/.*/texmf/web2c$|o) {
			$web2c = $_;
		}
	}
	die "web2c not found." unless ($web2c and -e $web2c);
	print "web2c is $web2c\n";
}

sub AppleScript($) {
	my ($script) = @_;
print "script=<<$script>>\n";
	my $answer = `osascript <<'_HERE_'\n$script\n_HERE_`;
	chomp $answer;
	return $answer;
}

my ($dir, $name) = $docPath =~ m|^(.*)/([^/]*)$|;
my $body = $name; $body =~ s/\.[^.]*$//;
my $cmd = "\"sh -c \\\"cd '$dir'; '$bin/$tex' -ini '$name'; mv -f '$body.fmt' '$body.log' '$web2c'; cd '$bin'; ln -sf '$tex' '$body'; '$bin/mktexlsr'\\\"\"";

AppleScript("do shell script $cmd with administrator privileges\ntell application \"JTeXEdit\" to Scan ShellTeX");
