#! /usr/bin/perl -w
use strict;
use utf8;
use encoding 'utf8';

# 行を結合する

# 文章をこのウィンドウに落とす

sub Join($$) {
	my ($left, $right) = @_;
	if ($left =~ /[[({]|\s/ or $right =~ /[])}.,;!?]|\s/
			# U-2150 (数字に準じるもの) 以上を全角と見なす
			or ord($left) >= 0x2150 and ord($right) >= 0x2150) {
		return "$left$right";
	} else {
		return "$left $right";
	}
}

print "\nLinesJoin\n";

my $File = shift or die;
open(IN, $File) or die $!;
my $text = join('', <IN>);
$text =~ s/^\n+//; # 最初と最後の空行は削除
$text =~ s/\n+$//;
$text =~ s/\n\n+/ /g; # 空行は space に
$text =~ s/(.)\n(.)/Join($1,$2)/ge;
print "$text\n\n";
