#! /perl -w
use strict;
use utf8;
use encoding 'utf8'; # filename

# 正規表現によるファイル名検索

# 使用法
# 8 行目の pattern を修正して，このウィンドウにフォルダを落とすと，名前が pattern に一致するファイルを表示する．

sub Match($) {
	return $_[0] =~ /幾何/; # pattern
}

sub Scan($);
sub Scan($) {
	my ($dir) = @_;
	return if (-l $dir or ! (-d $dir));
	unless (opendir(DIR, $dir)) {
		warn "can't scan '$dir': $!\n";
		return;
	}
	my @items = readdir DIR;
	closedir DIR;
	for my $item (@items) {
		next if ($item =~ /^\./);
		utf8::upgrade($item);
		my $file = "$dir/$item";
		print "$file\n" if (Match($item));
		Scan $file if (-d $file);
	}
}

while (my $dir = shift) {
	print "\n**** Find in $dir\n";
	Scan $dir;
}

print "**** end of find ****\n";

